;===============================================================
; Custom color koopa with wings, bouncing
; By Erik557
;
; Description: A koopa which bounces alternating between a high
; and a low jump. It's custom colored, too!
;
; Uses first extra bit: NO
;===============================================================

!ShellessKoopaNumber = $0C

YSpeeds:
       db $D0,$B0
XSpeeds:
       db $08,$F8

;=================================
; INIT and MAIN Wrappers
;=================================

print "INIT ",pc
       JSL $01ACF9          ;\ Get starting frame
       STA $1570,x          ;/
       AND #$01             ;\ And starting height too
       STA $C2,x            ;/
       JSR SubHorizPos      ;\
       TYA                  ; | Face player
       STA $157C,x          ;/
       TYX                  ;\
       LDA.l XSpeeds,x      ; | Set initial X speed
       LDX $15E9            ; |
       STA $B6,x            ;/
RTL

print "MAIN ",pc
       PHB : PHK : PLB      ; set data bank
       JSR BouncyKoopa      ; Main routine
       PLB                  ; restore
RTL

;========================
; Main routine
;========================

DrawNormalGFX:                    ;\ Draw the sprite
       PHB                  ; |\
       LDA #$01             ; | | set data bank to 01
       PHA                  ; | |
       PLB                  ; |/
       PHK                  ; |\
       PEA.w .drawn-1       ; | | jsl to 018bc3
       PEA.w $0180CA-1      ; | |
       JML $018BC3          ; |/
.drawn                      ;/
       PLB                  ; restore data bank
MainReturn:
       RTS                  ; return

BouncyKoopa:
       LDY #$00
       JSR SubOffScreen
       LDA $14C8,x
       CMP #$08
       BCS .pointer
       LDA #$00
       STA $7FAB34,x
       RTS
.pointer
       SEC
       SBC #$08
       ASL
       TAX
       JMP.w (koopaBehavior,x)

koopaBehavior:
       dw NormalState       ;   handle normally
       dw Stunned           ;   handle stunned
       dw Kicked            ;   handle kicked
       dw BeingHeld         ;   handle in mario's hands
       dw AfterGoal         ;   carried after goal was passed

Stunned:
       LDX $15E9
       LDA #$07
       STA $9E,x
       LDA $167A,x
       BPL +
       ASL $167A,x
       LSR $167A,x
+      LDA $9D
       BEQ +
       JMP .LockedSprites

+      JSR HandleInsideShell
       JSL $01802A
       LDA $1588,x
       BIT #$04
       BEQ +
       JSR XSpeedThing
       LDA $1588,x
+      BIT #$08
       BEQ .NotTouchingCeiling
       LDY #$10
       STY $AA,x
       AND #$03
       BNE .NotTouchingCeiling
       LDA $E4,x
       CLC
       ADC #$08
       STA $9A
       LDA $14E0,x
       ADC #$00
       STA $9B
       LDA $D8,x
       AND #$F0
       STA $98
       LDA $14D4,x
       STA $99
       LDA $1588,x
       AND #$20
       ASL #3
       ROL
       AND #$01
       STA $1933
       LDY #$00
       LDA $1868
       JSL $00F160
       LDA #$08
       STA $1FE2,x
       LDA $1588,x
.NotTouchingCeiling
       AND #$03
       BEQ +
       LDA $B6,x
       ASL
       PHP
       ROR $B6,x
       PLP
       ROR $B6,x
+      JSL $01803A
.LockedSprites
       PHB
       LDA #$01
       PHA
       PLB
       PHK
       PEA.w .Return-1
       PEA $80C9
       JML $019806
.Return
       PLB
       RTS

HandleInsideShell:
       LDA $1540,x
       ORA $1558,x
       STA $C2,x
       LDA $1558,x
       BEQ .Label1
       CMP #$01
       BNE .Label1
       ;   shelless koopa about to enter shell
       LDY $1594,x
       LDA $15D0,y
       BNE .Label1
       JSL $07F78B
       JSR SubHorizPos
       TYA
       STA $157C,x
       ASL $15F6,x
       LSR $15F6,x
       LDY $160E,x
       LDA #$08
       CPY #$03
       BNE +
       INC $187B,x
       LDA $166E,x
       ORA #$30
       STA $166E,x
       LDA #$0A
+      STA $14C8,x
       RTS

.IncrementStunTimer
       LDA $14
       AND #$01
       BNE .ReturnHandler
       INC $1540,x
.ReturnHandler
       RTS

.Label1
       LDA $1540,x
       BEQ .ReturnHandler
       CMP #$03
       BEQ .Unstun
       CMP #$01
       BNE .IncrementStunTimer
.Unstun
       ;   spawn shelless koopa
       JSL $02A9E4
       BMI .ReturnHandler
       LDA #$01
       STA $14C8,y
       LDA #!ShellessKoopaNumber
       TYX
       STA $7FAB9E,x
       JSL $07F7D2
       JSL $0187A7
       LDA #$08
       STA $7FAB10,x
       LDX $15E9
       LDA $E4,x
       STA $00E4,y
       LDA $14E0,x
       STA $14E0,y
       LDA $D8,x
       STA $00D8,y
       LDA $14D4,x
       STA $14D4,y
       LDA #$00
       STA $157C,y
       LDA #$10
       STA $1564,y
       LDA $164A,x
       STA $164A,y
       LDA $1540,x
       STZ $1540,x
       CMP #$01
       BEQ .arLabel66
       LDA #$D0
       STA $00AA,y
       PHY
       JSR SubHorizPos
       TYA
       PLY
       STA $157C,y
       PHX
       TAX
       LDA.l shellessXSpd,x
       STA $00B6,y
       PLX
       RTS
.arLabel66
       PHY
       JSR SubHorizPos
       LDA moreXSpd,y
       STY $00
       PLY
       STA $00B6,y
       LDA $00
       STA $157C,y
       STA $01
       LDA #$10
       STA $154C,y
       STA $1528,y
       RTS

shellessXSpd:
       db $08,$F8
moreXSpd:
       db $C0,$40

XSpeedThing:
       LDA $B6,x
       PHP
       BPL .arLabel08
       EOR #$FF
       INC
.arLabel08
       LSR
       PLP
       BPL .arLabel0F
       EOR #$FF
       INC
.arLabel0F
       STA $B6,x
       LDA $AA,x
       PHA
       LDA $1588,x
       BMI .arLabel0C
       LDA #$00
       LDY $15B8,x
       BEQ .arLabel0E
.arLabel0C
       LDA #$18
.arLabel0E
       STA $AA,x
       PLA
       LSR #2
       TAX
       LDA.l $0197AF,x
       LDX $15E9
       LDY $1588,x
       BMI .arLabel30
       STA $AA,x
.arLabel30
       RTS

Kicked:
       LDX $15E9
       LDA #$07
       STA $9E,x
       LDA $167A,x
       BPL +
       ASL $167A,x
       LSR $167A,x
+      PHB
       LDA #$01
       PHA
       PLB
       PHK
       PEA.w .Return-1
       PEA $80C9
       JML $019913
.Return
       PLB
       RTS

AfterGoal:
       LDX $15E9     ;   why lol
       RTS
BeingHeld:
       LDX $15E9
       LDA #$07
       STA $9E,x
       LDA $167A,x
       BPL +
       ASL $167A,x
       LSR $167A,x
+      PHB
       LDA #$01
       PHA
       PLB
       PHK
       PEA.w .Return-1
       PEA $80C9
       JML $019F71
.Return
       PLB
       RTS

NormalState:
       LDX $15E9
       LDA $9D
       BEQ +
       JMP .LockedSprites

+      INC $1570,x          ;\
       LDA $1570,x          ; |
       LSR #3               ; | set animation frame
       AND #$01             ; |
       STA $1602,x          ;/

       JSL $01802A          ; Update x and y positions + gravity
       JSL $018032          ; interact with sprites

       LDY $157C,x
       LDA XSpeeds,y
       CMP $B6,x
       BEQ +
       STA $B6,x
+      LDA $157C,x
       INC
       AND $1588,x
       AND #$03
       BEQ .SetY
       LDA $15AC,x
       BNE .SetY
       LDA #$08
       STA $15AC,x
       LDA $B6,x
       EOR #$FF
       INC
       STA $B6,x
       LDA $157C,x
       EOR #$01
       STA $157C,x

.SetY
       LDA $1510,x
       BEQ .Normal
       LDA $AA,x
       BEQ .CheckGnd
       DEC $AA,x
.CheckGnd
       LDA $1588,x
       AND #$04
       BEQ .LockedSprites
       LDA #$10
       STA $AA,x
       BRA .LockedSprites
.Normal
       DEC $AA,x
       LDA $1588,x          ;\
       BIT #$08             ; |
       BEQ +                ; | Reset speed if touching ceiling
       STZ $AA,x            ; |
       BRA .LockedSprites   ;/
+      AND #$04             ;\ Don't update while on air
       BEQ .LockedSprites   ;/
       LDA $C2,x            ;\
       AND #$01             ; |
       TAY                  ; | Increase speed
       LDA YSpeeds,y        ; |
       STA $AA,x            ;/
       INC $C2,x

.LockedSprites
       JSR DrawNormalGFX    ; GFX routine
       LDA $154C,x
       ORA $9D
       BNE .Return3
       JSL $01A7DC          ;\
       BCS .Int             ; | interact with mario
.Return3                    ; | if not in contact, return
       RTS                  ;/

.Int
       LDA $1490
       BEQ +
       JMP .Star

+      LDA #$14
       STA $01
       LDA $05
       SEC
       SBC $01
       ROL $00
       CMP $D3
       PHP
       LSR $00
       LDA $0B
       SBC #$00
       PLP
       SBC $D4
       BPL +
       JMP .PreHurt

+      LDA $7D
       BPL +
       LDA $1697
       BNE +
       JMP .PreHurt
+      JSL $01AB99
       LDA #$08
       STA $154C,x

       LDA $140D
       ORA $187A
       BEQ +
       JMP .SpinKill

+      JSL $01AA33
       LDA $1510,x
       BEQ .Stomp1
       LDA #$09
       STA $14C8,x
       JSR HandleInsideShell_Unstun
       LDA $157C,y
       EOR #$01
       STA $157C,y
       ASL $167A,x
       LSR $167A,x
       BRA +

.Stomp1
       LDA #$07
       STA $9E,x
       LDA #$01
       STA $1510,x
+      STZ $AA,x

       PHY
       LDA $1697
       CLC
       ADC $1626,X
       INC $1697
       TAY
       INY
       CPY #$08
       BCS +
       LDA KillSFX,y
       STA $1DF9
+      TYA
       CMP #$08
       BCC +
       LDA #$08
+      JSL $02ACE5
       PLY
       RTS

.Cape
       LDA $0E
       CMP #$35
       BEQ +
       JSL $01AB6F

+      LDA #$00
       JSL $02ACE5
       LDA #$09
       STA $14C8,x
       ASL $15F6,x
       SEC
       ROR $15F6,x
       LDA #$07
       STA $9E,x

       LDA #$FF
       STA $1540,x
       STZ $1558,x
       LDA #$C0
       LDY $0E
       BEQ +
       LDA #$B0
       CPY #$02
       BNE +
       LDA #$C0
+      STA $AA,x

       JSR SubHorizPos
       LDA StunSpeeds,y
       STA $B6,x
       TYA
       EOR #$01
       STA $157C,x
       RTS

.PreHurt
       LDA $13ED
       BNE .Star
       LDA $187A
       BNE .ReturnInteract
       JSL $00F5B7
       LDX $15E9
       JSR SubHorizPos
       TYA
       STA $157C,x
       RTS

.SpinKill
       LDA #$04
       STA $14C8,x
       LDA #$1F
       STA $1540,x
       LDA #$08
       STA $1DF9
       JSL $07FC3B
       LDA #$F8
       STA $7D

.ReturnInteract
       RTS                  ; return

.Star
       JSL $01AB6F
       INC $18D2
       LDA $18D2
       CMP #$08
       BCC +
       LDA #$08
       STA $18D2
+      JSL $02ACE5
       LDY $18D2
       CPY #$08
       BCS +
       LDA KillSFX,y
       STA $1DF9
+      LDA #$02
       STA $14C8,x
       LDA #$D0
       STA $AA,x
       JSR SubHorizPos
       LDA KillSpeeds,y
       STA $B6,x
       LDA #$07
       STA $9E,x
       RTS

KillSFX:
       db $00,$13,$14,$15,$16,$17,$18,$19
KillSpeeds:
       db $F0,$10
StunSpeeds:
       db $F8,$08

;==================
  SubHorizPos:
;==================

       LDY #$00
       LDA $94
       SEC
       SBC $E4,x
       STA $0F
       LDA $95
       SBC $14E0,x
       BPL $01
       INY
       RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  SubOffScreen:           ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       LDA $15A0,x
       ORA $186C,x
       BEQ .Return2
       LDA $167A,x
       AND #$04
       BNE .Return2
       LDA $5B
       LSR A
       BCS .VerticalLevel
       LDA $D8,x
       ADC #$50
       LDA $14D4,x
       ADC #$00
       CMP #$02
       BCS .EraseSprite
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC .AddTable,y
       SEC
       SBC $1A
       CMP .CmpTable,y
.Common
       SEP #$20
       BCC .Return2
.EraseSprite
       LDA $14C8,x
       CMP #$08
       BCC .KillSprite
       LDY $161A,x
       CPY #$FF
       BEQ .KillSprite
       LDA $1938,y
       AND #$FE
       STA $1938,y
.KillSprite
       STZ $14C8,x
.Return2
       RTS

.VerticalLevel
       LDA $13
       LSR A
       BCS .CheckY
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC.w #$0040
       CMP.w #$0280
       BRA .Common
.CheckY
       LDA $14D4,x
       XBA
       LDA $D8,x
       REP #$20
       SBC $1C
       CLC
       ADC.w #$0070
       CMP.w #$01D0
       BRA .Common

.AddTable
       dw $0040,$0040,$0010,$0070
       dw $0090,$0050,$0080,$FFC0
.CmpTable
       dw $0170,$01E0,$01B0,$01D0
       dw $0230,$01B0,$0220,$0160

